
    /*!
    * structured-editor-ui v0.1.6
    * (c) 2019 HollyIT (limited liability)
    * @license MIT
    */
  
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('popper.js'), require('@ledecmf/editor-core'), require('prosemirror-commands'), require('@ledecmf/structured-editor'), require('v-click-outside'), require('prosemirror-utils'), require('@ledecmf/structured-editor-extensions'), require('@ledecmf/structured-editor-utils')) :
    typeof define === 'function' && define.amd ? define(['exports', 'popper.js', '@ledecmf/editor-core', 'prosemirror-commands', '@ledecmf/structured-editor', 'v-click-outside', 'prosemirror-utils', '@ledecmf/structured-editor-extensions', '@ledecmf/structured-editor-utils'], factory) :
    (global = global || self, factory(global.structuredEditorUI = {}, global.Popper, global.editorCore, global.prosemirrorCommands, global.structuredEditor, global.vClickOutside, global.prosemirrorUtils, global.structuredEditorExtensions, global.structuredEditorUtils));
}(this, function (exports, Popper, editorCore, prosemirrorCommands, structuredEditor, vClickOutside, prosemirrorUtils, structuredEditorExtensions, structuredEditorUtils) { 'use strict';

    Popper = Popper && Popper.hasOwnProperty('default') ? Popper['default'] : Popper;
    vClickOutside = vClickOutside && vClickOutside.hasOwnProperty('default') ? vClickOutside['default'] : vClickOutside;

    //
    var script = {
      name: 'MenuItem',
      components: {
        EditorButton: editorCore.EditorButton
      },
      props: {
        item: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        showLabel: Boolean
      },
      methods: {
        extensionCommand: function extensionCommand(item) {
          item.command(this.editor);
          this.$emit('exec', item);
        }
      },
      mounted: function mounted() {}
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
    /* server only */
    , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
      if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
      } // Vue.extend constructor export interop.


      var options = typeof script === 'function' ? script.options : script; // render functions

      if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true; // functional template

        if (isFunctionalTemplate) {
          options.functional = true;
        }
      } // scopedId


      if (scopeId) {
        options._scopeId = scopeId;
      }

      var hook;

      if (moduleIdentifier) {
        // server build
        hook = function hook(context) {
          // 2.3 injection
          context = context || // cached call
          this.$vnode && this.$vnode.ssrContext || // stateful
          this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
          // 2.2 with runInNewContext: true

          if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
            context = __VUE_SSR_CONTEXT__;
          } // inject component styles


          if (style) {
            style.call(this, createInjectorSSR(context));
          } // register component module identifier for async chunk inference


          if (context && context._registeredComponents) {
            context._registeredComponents.add(moduleIdentifier);
          }
        }; // used by ssr in case component is cached and beforeCreate
        // never gets called


        options._ssrRegister = hook;
      } else if (style) {
        hook = shadowMode ? function () {
          style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
        } : function (context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook) {
        if (options.functional) {
          // register for functional component in vue file
          var originalRender = options.render;

          options.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context);
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = options.beforeCreate;
          options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }

      return script;
    }

    var normalizeComponent_1 = normalizeComponent;

    var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
    function createInjector(context) {
      return function (id, style) {
        return addStyle(id, style);
      };
    }
    var HEAD = document.head || document.getElementsByTagName('head')[0];
    var styles = {};

    function addStyle(id, css) {
      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = {
        ids: new Set(),
        styles: []
      });

      if (!style.ids.has(id)) {
        style.ids.add(id);
        var code = css.source;

        if (css.map) {
          // https://developer.chrome.com/devtools/docs/javascript-debugging
          // this makes source maps inside style tags work properly in Chrome
          code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

          code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
        }

        if (!style.element) {
          style.element = document.createElement('style');
          style.element.type = 'text/css';
          if (css.media) style.element.setAttribute('media', css.media);
          HEAD.appendChild(style.element);
        }

        if ('styleSheet' in style.element) {
          style.styles.push(code);
          style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
        } else {
          var index = style.ids.size - 1;
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) style.element.removeChild(nodes[index]);
          if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
        }
      }
    }

    var browser = createInjector;

    /* script */
    const __vue_script__ = script;

    /* template */
    var __vue_render__ = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        { staticClass: "menu-item" },
        [
          _vm.item.component
            ? _c(_vm.item.component, {
                tag: "component",
                attrs: {
                  item: _vm.item,
                  editor: _vm.editor,
                  "show-label": _vm.showLabel
                },
                on: {
                  exec: function($event) {
                    return _vm.$emit("exec", _vm.item)
                  }
                }
              })
            : _vm.item.isAvailable(_vm.editor)
            ? _c("editor-button", {
                attrs: {
                  "show-label": _vm.showLabel,
                  icon: _vm.item.icon,
                  label: _vm.item.label,
                  active: _vm.item.isActive(_vm.editor)
                },
                on: {
                  click: function($event) {
                    return _vm.extensionCommand(_vm.item)
                  }
                }
              })
            : _vm._e()
        ],
        1
      )
    };
    var __vue_staticRenderFns__ = [];
    __vue_render__._withStripped = true;

      /* style */
      const __vue_inject_styles__ = function (inject) {
        if (!inject) return
        inject("data-v-63af7ab1_0", { source: "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n", map: {"version":3,"sources":[],"names":[],"mappings":"","file":"MenuItem.vue"}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__ = "data-v-63af7ab1";
      /* module identifier */
      const __vue_module_identifier__ = undefined;
      /* functional template */
      const __vue_is_functional_template__ = false;
      /* style inject SSR */
      

      
      var MenuItem = normalizeComponent_1(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        browser,
        undefined
      );

    //
    var script$1 = {
      name: 'BlockMenu',
      components: {
        EditorButton: editorCore.EditorButton,
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          top: 0,
          only: null,
          isActive: false,
          left: 0
        };
      },
      mounted: function mounted() {
        this.$editor.$on('selection', this.onSelection);
      },
      beforeDestroy: function beforeDestroy() {
        this.hide();
        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        onExec: function onExec() {
          this.hide();
        },
        onSelection: function onSelection(selection) {
          this.selection = selection;
          var state = selection.view.state;
          var parent = this.$editor.$el.parentNode;
          var editorBoundings = parent.getBoundingClientRect();
          var cursorBoundings = selection.view.coordsAtPos(state.selection.$anchor.pos);
          var currentDom = selection.view.domAtPos(state.selection.$anchor.pos);

          if (currentDom && currentDom.node && currentDom.node.getBoundingClientRect) {
            var domOffset = currentDom.node.getBoundingClientRect();
            this.top = cursorBoundings.top - editorBoundings.top;
            this.left = domOffset.x - editorBoundings.left - 36;
          }
        },
        open: function open() {
          var _this = this;

          this.$editor.focus();
          this.isActive = true;
          this.$nextTick(function () {
            _this.popper = new Popper(_this.$refs.toggle, _this.$refs.toolbar, {
              placement: 'bottom-start'
            });
          });
          document.addEventListener('mousedown', this.maybeHide);
        },
        toggle: function toggle() {
          if (this.isActive) {
            this.hide();
          } else {
            this.open();
          }
        },
        hide: function hide() {
          if (this.popper) {
            this.popper.destroy();
            this.popper = null;
          }

          this.isActive = false;
          document.removeEventListener('mousedown', this.maybeHide);
        },
        maybeHide: function maybeHide(event) {
          if (!this.$el.contains(event.target)) {
            this.hide();
          }
        }
      }
    };

    /* script */
    const __vue_script__$1 = script$1;

    /* template */
    var __vue_render__$1 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          staticClass: "lede-block-menu",
          style: { top: _vm.top + "px", left: _vm.left + "px" }
        },
        [
          _c(
            "div",
            { ref: "toggle" },
            [
              _c("editor-button", {
                attrs: { icon: "paragraph2" },
                on: { click: _vm.toggle }
              })
            ],
            1
          ),
          _vm._v(" "),
          _vm.isActive
            ? _c(
                "div",
                { ref: "toolbar", staticClass: "menu-inner" },
                [
                  _vm._l(_vm.items, function(item, idx) {
                    return [
                      !_vm.only || _vm.only === item
                        ? _c("menu-item", {
                            key: idx,
                            attrs: { item: item, editor: _vm.editor },
                            on: { exec: _vm.onExec }
                          })
                        : _vm._e()
                    ]
                  }),
                  _vm._v(" "),
                  _c("div", { staticClass: "menu-arrow", attrs: { "x-arrow": "" } })
                ],
                2
              )
            : _vm._e()
        ]
      )
    };
    var __vue_staticRenderFns__$1 = [];
    __vue_render__$1._withStripped = true;

      /* style */
      const __vue_inject_styles__$1 = function (inject) {
        if (!inject) return
        inject("data-v-e6305cba_0", { source: ".lede-block-menu {\n  position: absolute;\n  z-index: 100;\n  width: 24px;\n  height: 24px;\n}\n.lede-block-menu .menu-inner {\n  display: flex;\n  border-radius: 4px;\n}\n.lede-block-menu .menu-inner button {\n  display: inline-flex;\n  align-items: center;\n  padding: 5px;\n}\n.lede-block-menu .lede-block-selector {\n  display: flex;\n  align-items: center;\n  height: 100%;\n  padding: 5px;\n}\n.lede-block-menu .lede-block-selector select {\n  border-radius: 0.25rem;\n  padding: 0;\n  height: 28px;\n}\n\n/*# sourceMappingURL=BlockMenu.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\BlockMenu.vue","BlockMenu.vue"],"names":[],"mappings":"AA+HA;EACA,kBAAA;EACA,YAAA;EACA,WAAA;EACA,YAAA;AC9HA;ADgIA;EACA,aAAA;EACA,kBAAA;AC9HA;ADgIA;EACA,oBAAA;EACA,mBAAA;EACA,YAAA;AC9HA;ADmIA;EACA,aAAA;EACA,mBAAA;EACA,YAAA;EACA,YAAA;ACjIA;ADmIA;EACA,sBAAA;EACA,UAAA;EACA,YAAA;ACjIA;;AAEA,wCAAwC","file":"BlockMenu.vue","sourcesContent":["<template>\r\n    <div class=\"lede-block-menu\" :style=\"{'top' : top + 'px', 'left' : left + 'px'}\">\r\n        <div ref=\"toggle\">\r\n            <editor-button icon=\"paragraph2\" @click=\"toggle\"></editor-button>\r\n        </div>\r\n        <div class=\"menu-inner\" ref=\"toolbar\" v-if=\"isActive\">\r\n            <template v-for=\"(item, idx) in items\">\r\n                <menu-item v-if=\"!only || only === item\" :item=\"item\" :key=\"idx\" :editor=\"editor\"\r\n                           @exec=\"onExec\"></menu-item>\r\n            </template>\r\n            <div class=\"menu-arrow\" x-arrow></div>\r\n        </div>\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n    import Popper from 'popper.js'\r\n    import MenuItem from './MenuItem.vue'\r\n    import {EditorButton} from '@ledecmf/editor-core'\r\n\r\n    export default {\r\n        name: 'BlockMenu',\r\n        components: {EditorButton, MenuItem},\r\n        provide() {\r\n            return {\r\n                '$menu': this,\r\n            }\r\n        },\r\n\r\n        inject: ['$editor'],\r\n        props: {\r\n            menu: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            editor: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n        },\r\n\r\n        computed: {\r\n            items() {\r\n                return this.menu.all()\r\n            },\r\n        },\r\n\r\n        data() {\r\n            return {\r\n                top: 0,\r\n                only: null,\r\n                isActive: false,\r\n                left: 0,\r\n            }\r\n        },\r\n        mounted() {\r\n            this.$editor.$on('selection', this.onSelection)\r\n\r\n        },\r\n\r\n        beforeDestroy() {\r\n            this.hide()\r\n            this.$editor.$off('selection', this.onSelection)\r\n        },\r\n\r\n        methods: {\r\n            onExec() {\r\n                this.hide()\r\n            },\r\n\r\n            onSelection(selection) {\r\n                this.selection = selection\r\n                const state = selection.view.state\r\n                let parent = this.$editor.$el.parentNode\r\n                const editorBoundings = parent.getBoundingClientRect()\r\n                const cursorBoundings = selection.view.coordsAtPos(state.selection.$anchor.pos)\r\n                const currentDom = selection.view.domAtPos(state.selection.$anchor.pos)\r\n                if (currentDom && currentDom.node && currentDom.node.getBoundingClientRect) {\r\n                    const domOffset = currentDom.node.getBoundingClientRect()\r\n                    this.top = cursorBoundings.top - editorBoundings.top\r\n                    this.left = domOffset.x - editorBoundings.left - 36\r\n                }\r\n\r\n            },\r\n\r\n            open() {\r\n                this.$editor.focus()\r\n                this.isActive = true\r\n                this.$nextTick(() => {\r\n                    this.popper = new Popper(this.$refs.toggle, this.$refs.toolbar, {\r\n                        placement: 'bottom-start',\r\n                    })\r\n                })\r\n                document.addEventListener('mousedown', this.maybeHide)\r\n            },\r\n\r\n            toggle() {\r\n                if (this.isActive) {\r\n                    this.hide()\r\n                } else {\r\n                    this.open()\r\n                }\r\n            },\r\n\r\n            hide() {\r\n                if (this.popper) {\r\n                    this.popper.destroy()\r\n                    this.popper = null\r\n                }\r\n                this.isActive = false\r\n                document.removeEventListener('mousedown', this.maybeHide)\r\n            },\r\n\r\n            maybeHide(event) {\r\n                if (!this.$el.contains(event.target)) {\r\n                    this.hide()\r\n                }\r\n            },\r\n\r\n        },\r\n\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n\r\n    .lede-block-menu {\r\n        position: absolute;\r\n        z-index: 100;\r\n        width: 24px;\r\n        height: 24px;\r\n\r\n        .menu-inner {\r\n            display: flex;\r\n            border-radius: 4px;\r\n\r\n            button {\r\n                display: inline-flex;\r\n                align-items: center;\r\n                padding: 5px;\r\n\r\n            }\r\n        }\r\n\r\n        .lede-block-selector {\r\n            display: flex;\r\n            align-items: center;\r\n            height: 100%;\r\n            padding: 5px;\r\n\r\n            select {\r\n                border-radius: .25rem;\r\n                padding: 0;\r\n                height: 28px;\r\n            }\r\n        }\r\n    }\r\n\r\n</style>\r\n",".lede-block-menu {\n  position: absolute;\n  z-index: 100;\n  width: 24px;\n  height: 24px;\n}\n.lede-block-menu .menu-inner {\n  display: flex;\n  border-radius: 4px;\n}\n.lede-block-menu .menu-inner button {\n  display: inline-flex;\n  align-items: center;\n  padding: 5px;\n}\n.lede-block-menu .lede-block-selector {\n  display: flex;\n  align-items: center;\n  height: 100%;\n  padding: 5px;\n}\n.lede-block-menu .lede-block-selector select {\n  border-radius: 0.25rem;\n  padding: 0;\n  height: 28px;\n}\n\n/*# sourceMappingURL=BlockMenu.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$1 = undefined;
      /* module identifier */
      const __vue_module_identifier__$1 = undefined;
      /* functional template */
      const __vue_is_functional_template__$1 = false;
      /* style inject SSR */
      

      
      var BlockMenu = normalizeComponent_1(
        { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
        __vue_inject_styles__$1,
        __vue_script__$1,
        __vue_scope_id__$1,
        __vue_is_functional_template__$1,
        __vue_module_identifier__$1,
        browser,
        undefined
      );

    //
    var script$2 = {
      name: 'BlockTypeSelector',
      inject: ['$editor'],
      props: {
        editor: {
          type: Object,
          required: true
        },
        item: Object
      },
      computed: {
        types: function types() {
          return this.item.all();
        },
        activeBlock: {
          get: function get() {
            var _this = this;

            var active = null;
            this.types.forEach(function (type) {
              if (_this.editor.isActive[type.command] && _this.editor.isActive[type.command](type.attrs)) {
                active = type;
              }
            });
            return active;
          },
          set: function set(type) {
            this.editor.commands[type.command](type.attrs);
          }
        }
      }
    };

    /* script */
    const __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$2 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c("div", { staticClass: "lede-block-selector" }, [
        _c(
          "select",
          {
            directives: [
              {
                name: "model",
                rawName: "v-model",
                value: _vm.activeBlock,
                expression: "activeBlock"
              }
            ],
            on: {
              change: function($event) {
                var $$selectedVal = Array.prototype.filter
                  .call($event.target.options, function(o) {
                    return o.selected
                  })
                  .map(function(o) {
                    var val = "_value" in o ? o._value : o.value;
                    return val
                  });
                _vm.activeBlock = $event.target.multiple
                  ? $$selectedVal
                  : $$selectedVal[0];
              }
            }
          },
          _vm._l(_vm.types, function(type, idx) {
            return _c("option", {
              key: idx,
              domProps: { value: type, textContent: _vm._s(type.label) }
            })
          }),
          0
        )
      ])
    };
    var __vue_staticRenderFns__$2 = [];
    __vue_render__$2._withStripped = true;

      /* style */
      const __vue_inject_styles__$2 = function (inject) {
        if (!inject) return
        inject("data-v-feeea942_0", { source: "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n", map: {"version":3,"sources":[],"names":[],"mappings":"","file":"BlockTypeSelector.vue"}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$2 = "data-v-feeea942";
      /* module identifier */
      const __vue_module_identifier__$2 = undefined;
      /* functional template */
      const __vue_is_functional_template__$2 = false;
      /* style inject SSR */
      

      
      var BlockTypeSelector = normalizeComponent_1(
        { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
        __vue_inject_styles__$2,
        __vue_script__$2,
        __vue_scope_id__$2,
        __vue_is_functional_template__$2,
        __vue_module_identifier__$2,
        browser,
        undefined
      );

    //
    var script$3 = {
      name: 'EditorDialog',
      components: {
        EditorButton: editorCore.EditorButton
      }
    };

    /* script */
    const __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$3 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c("transition", { attrs: { name: "lede-editor-dialog" } }, [
        _c("div", { staticClass: "lede-editor-dialog" }, [
          _c("div", { staticClass: "dialog-window" }, [
            _c("div", { staticClass: "dialog-header" }, [
              _c("div", { staticClass: "inner" }, [_vm._t("header")], 2),
              _vm._v(" "),
              _c(
                "div",
                { staticClass: "close" },
                [
                  _c("editor-button", {
                    attrs: { icon: "close" },
                    on: {
                      click: function($event) {
                        return _vm.$emit("close")
                      }
                    }
                  })
                ],
                1
              )
            ]),
            _vm._v(" "),
            _c("div", { staticClass: "dialog-body" }, [_vm._t("default")], 2),
            _vm._v(" "),
            _vm.$slots.actions
              ? _c("div", { staticClass: "dialog-footer" }, [_vm._t("actions")], 2)
              : _vm._e()
          ])
        ])
      ])
    };
    var __vue_staticRenderFns__$3 = [];
    __vue_render__$3._withStripped = true;

      /* style */
      const __vue_inject_styles__$3 = function (inject) {
        if (!inject) return
        inject("data-v-0df74648_0", { source: ".lede-editor-dialog-enter,\n.lede-editor-dialog-leave-active {\n  opacity: 0;\n}\n.lede-editor-dialog-enter-active,\n.lede-editor-dialog-leave-active {\n  transition: opacity 0.25s ease;\n}\n.lede-editor-dialog {\n  z-index: 500;\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background: rgba(0, 0, 0, 0.3);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.lede-editor-dialog .dialog-window {\n  background: #fff;\n  border-radius: 4px;\n  max-height: 95%;\n  display: flex;\n  flex-direction: column;\n}\n.lede-editor-dialog .dialog-header {\n  padding: 15px;\n  font-size: 16px;\n  font-weight: bold;\n  border-bottom: 1px solid #ccc;\n  display: flex;\n  align-items: center;\n}\n.lede-editor-dialog .dialog-header .inner {\n  flex: 1;\n}\n.lede-editor-dialog .dialog-body {\n  overflow: auto;\n  padding: 15px;\n  flex: 1;\n}\n\n/*# sourceMappingURL=EditorDialog.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\EditorDialog.vue","EditorDialog.vue"],"names":[],"mappings":"AAoCA;;EAEA,UAAA;ACnCA;ADsCA;;EAEA,8BAAA;ACnCA;ADqCA;EACA,YAAA;EACA,eAAA;EACA,MAAA;EACA,OAAA;EACA,QAAA;EACA,SAAA;EACA,8BAAA;EACA,aAAA;EACA,mBAAA;EACA,uBAAA;AClCA;ADoCA;EACA,gBAAA;EACA,kBAAA;EACA,eAAA;EACA,aAAA;EACA,sBAAA;AClCA;ADqCA;EACA,aAAA;EACA,eAAA;EACA,iBAAA;EACA,6BAAA;EACA,aAAA;EACA,mBAAA;ACnCA;ADqCA;EACA,OAAA;ACnCA;ADwCA;EACA,cAAA;EACA,aAAA;EACA,OAAA;ACtCA;;AAEA,2CAA2C","file":"EditorDialog.vue","sourcesContent":["<template>\n    <transition name=\"lede-editor-dialog\">\n\n        <div class=\"lede-editor-dialog\">\n            <div class=\"dialog-window\">\n                <div class=\"dialog-header\">\n                    <div class=\"inner\">\n                        <slot name=\"header\"></slot>\n                    </div>\n\n                    <div class=\"close\">\n                        <editor-button icon=\"close\" @click=\"$emit('close')\"></editor-button>\n                    </div>\n\n                </div>\n                <div class=\"dialog-body\">\n                    <slot></slot>\n                </div>\n                <div class=\"dialog-footer\" v-if=\"$slots.actions\">\n                    <slot name=\"actions\"></slot>\n                </div>\n            </div>\n        </div>\n    </transition>\n</template>\n\n<script>\n    import {EditorButton} from '@ledecmf/editor-core'\n\n    export default {\n        name: 'EditorDialog',\n        components: {EditorButton},\n    }\n</script>\n\n<style lang=\"scss\">\n    .lede-editor-dialog-enter,\n    .lede-editor-dialog-leave-active {\n        opacity: 0;\n    }\n\n    .lede-editor-dialog-enter-active,\n    .lede-editor-dialog-leave-active {\n        transition: opacity .25s ease\n    }\n    .lede-editor-dialog {\n        z-index: 500;\n        position: fixed;\n        top: 0;\n        left: 0;\n        right: 0;\n        bottom: 0;\n        background: rgba(0, 0, 0, 0.3);\n        display: flex;\n        align-items: center;\n        justify-content: center;\n\n        .dialog-window {\n            background: #fff;\n            border-radius: 4px;\n            max-height: 95%;\n            display: flex;\n            flex-direction: column;\n        }\n\n        .dialog-header {\n            padding: 15px;\n            font-size: 16px;\n            font-weight: bold;\n            border-bottom: 1px solid #ccc;\n            display: flex;\n            align-items: center;\n\n            .inner {\n                flex: 1;\n            }\n\n        }\n\n        .dialog-body {\n            overflow: auto;\n            padding: 15px;\n            flex: 1;\n        }\n    }\n</style>\n",".lede-editor-dialog-enter,\n.lede-editor-dialog-leave-active {\n  opacity: 0;\n}\n\n.lede-editor-dialog-enter-active,\n.lede-editor-dialog-leave-active {\n  transition: opacity 0.25s ease;\n}\n\n.lede-editor-dialog {\n  z-index: 500;\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background: rgba(0, 0, 0, 0.3);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.lede-editor-dialog .dialog-window {\n  background: #fff;\n  border-radius: 4px;\n  max-height: 95%;\n  display: flex;\n  flex-direction: column;\n}\n.lede-editor-dialog .dialog-header {\n  padding: 15px;\n  font-size: 16px;\n  font-weight: bold;\n  border-bottom: 1px solid #ccc;\n  display: flex;\n  align-items: center;\n}\n.lede-editor-dialog .dialog-header .inner {\n  flex: 1;\n}\n.lede-editor-dialog .dialog-body {\n  overflow: auto;\n  padding: 15px;\n  flex: 1;\n}\n\n/*# sourceMappingURL=EditorDialog.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$3 = undefined;
      /* module identifier */
      const __vue_module_identifier__$3 = undefined;
      /* functional template */
      const __vue_is_functional_template__$3 = false;
      /* style inject SSR */
      

      
      var EditorDialog = normalizeComponent_1(
        { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
        __vue_inject_styles__$3,
        __vue_script__$3,
        __vue_scope_id__$3,
        __vue_is_functional_template__$3,
        __vue_module_identifier__$3,
        browser,
        undefined
      );

    //
    var script$4 = {
      name: 'InsertDialog',
      inject: ['$editor'],
      components: {
        MenuItem: MenuItem,
        EditorDialog: EditorDialog,
        EditorButton: editorCore.EditorButton,
        EditorIcon: editorCore.EditorIcon
      },
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          showItems: false
        };
      },
      methods: {
        insert: function insert(item) {
          item.command(this.editor);
          this.showItems = false;
        }
      }
    };

    /* script */
    const __vue_script__$4 = script$4;

    /* template */
    var __vue_render__$4 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        { staticClass: "node-insert-dialog" },
        [
          _c("editor-button", {
            attrs: { icon: "add", label: "Browse more blocks" },
            on: {
              click: function($event) {
                _vm.showItems = true;
              }
            }
          }),
          _vm._v(" "),
          _c(
            "editor-dialog",
            {
              directives: [
                {
                  name: "show",
                  rawName: "v-show",
                  value: _vm.showItems,
                  expression: "showItems"
                }
              ],
              on: {
                close: function($event) {
                  _vm.showItems = false;
                }
              },
              scopedSlots: _vm._u([
                {
                  key: "header",
                  fn: function() {
                    return [_vm._v("Insert new block")]
                  },
                  proxy: true
                }
              ])
            },
            [
              _vm._v(" "),
              _c(
                "div",
                { staticClass: "insert-items" },
                _vm._l(_vm.items, function(item) {
                  return _c(
                    "div",
                    { staticClass: "insert-item" },
                    [
                      _c("menu-item", {
                        attrs: {
                          "show-label": true,
                          item: item,
                          editor: _vm.editor
                        },
                        on: {
                          exec: function($event) {
                            _vm.showItems = false;
                          }
                        }
                      })
                    ],
                    1
                  )
                }),
                0
              )
            ]
          )
        ],
        1
      )
    };
    var __vue_staticRenderFns__$4 = [];
    __vue_render__$4._withStripped = true;

      /* style */
      const __vue_inject_styles__$4 = function (inject) {
        if (!inject) return
        inject("data-v-767bfe44_0", { source: ".node-insert-dialog .insert-items {\n  min-width: 250px;\n}\n.node-insert-dialog .insert-item {\n  margin: 10px 0;\n  align-items: center;\n  cursor: pointer;\n}\n.node-insert-dialog .insert-item button {\n  text-align: left;\n}\n.node-insert-dialog .insert-item .menu-item {\n  width: 100%;\n  display: block;\n}\n.node-insert-dialog .insert-item .editor-icon {\n  margin-right: 15px;\n}\n.node-insert-dialog .insert-item .lede-editor-button {\n  display: flex;\n  align-items: center;\n  width: 100%;\n  padding: 10px 5px;\n}\n.node-insert-dialog .insert-item .lede-editor-button:hover {\n  background: #2cb5ff;\n  color: #fff;\n}\n.node-insert-dialog .insert-item .lede-editor-button:hover svg {\n  fill: #fff;\n}\n\n/*# sourceMappingURL=InsertDialog.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\InsertDialog.vue","InsertDialog.vue"],"names":[],"mappings":"AA2DA;EACA,gBAAA;AC1DA;AD6DA;EACA,cAAA;EACA,mBAAA;EACA,eAAA;AC3DA;AD4DA;EACA,gBAAA;AC1DA;AD6DA;EACA,WAAA;EACA,cAAA;AC3DA;AD6DA;EACA,kBAAA;AC3DA;AD6DA;EACA,aAAA;EACA,mBAAA;EACA,WAAA;EACA,iBAAA;AC3DA;AD6DA;EACA,mBAAA;EACA,WAAA;AC3DA;AD6DA;EACA,UAAA;AC3DA;;AAEA,2CAA2C","file":"InsertDialog.vue","sourcesContent":["<template>\r\n    <div class=\"node-insert-dialog\">\r\n        <editor-button icon=\"add\" label=\"Browse more blocks\" @click=\"showItems=true\"></editor-button>\r\n        <editor-dialog v-show=\"showItems\" @close=\"showItems=false\">\r\n            <template v-slot:header>Insert new block</template>\r\n            <div class=\"insert-items\">\r\n\r\n                <div class=\"insert-item\" v-for=\"item in items\">\r\n                    <menu-item :show-label=\"true\" :item=\"item\" :editor=\"editor\" @exec=\"showItems = false\"></menu-item>\r\n                </div>\r\n            </div>\r\n        </editor-dialog>\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n    import EditorDialog from './EditorDialog.vue'\r\n    import {EditorButton, EditorIcon} from '@ledecmf/editor-core'\r\n    import MenuItem from './MenuItem.vue'\r\n    export default {\r\n        name: 'InsertDialog',\r\n        inject: ['$editor'],\r\n        components:{MenuItem, EditorDialog, EditorButton, EditorIcon},\r\n        props: {\r\n            menu: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            editor: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n        },\r\n\r\n        computed: {\r\n            items() {\r\n                return this.menu.all()\r\n            },\r\n        },\r\n\r\n        data() {\r\n            return {\r\n                showItems: false,\r\n            }\r\n        },\r\n\r\n        methods: {\r\n            insert(item) {\r\n                item.command(this.editor)\r\n                this.showItems = false;\r\n            }\r\n        },\r\n\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n    .node-insert-dialog {\r\n        .insert-items {\r\n            min-width: 250px;\r\n        }\r\n\r\n        .insert-item {\r\n            margin: 10px 0;\r\n            align-items: center;\r\n            cursor: pointer;\r\n            button {\r\n                text-align: left;\r\n            }\r\n\r\n            .menu-item {\r\n                width: 100%;\r\n                display: block;\r\n            }\r\n            .editor-icon {\r\n                margin-right: 15px;\r\n            }\r\n            .lede-editor-button {\r\n                display:flex;\r\n                align-items: center;\r\n                width: 100%;\r\n                padding:10px 5px;\r\n            }\r\n            .lede-editor-button:hover {\r\n                background: #2cb5ff;\r\n                color: #fff;\r\n\r\n                svg {\r\n                    fill: #fff;\r\n                }\r\n            }\r\n        }\r\n    }\r\n</style>\r\n",".node-insert-dialog .insert-items {\n  min-width: 250px;\n}\n.node-insert-dialog .insert-item {\n  margin: 10px 0;\n  align-items: center;\n  cursor: pointer;\n}\n.node-insert-dialog .insert-item button {\n  text-align: left;\n}\n.node-insert-dialog .insert-item .menu-item {\n  width: 100%;\n  display: block;\n}\n.node-insert-dialog .insert-item .editor-icon {\n  margin-right: 15px;\n}\n.node-insert-dialog .insert-item .lede-editor-button {\n  display: flex;\n  align-items: center;\n  width: 100%;\n  padding: 10px 5px;\n}\n.node-insert-dialog .insert-item .lede-editor-button:hover {\n  background: #2cb5ff;\n  color: #fff;\n}\n.node-insert-dialog .insert-item .lede-editor-button:hover svg {\n  fill: #fff;\n}\n\n/*# sourceMappingURL=InsertDialog.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$4 = undefined;
      /* module identifier */
      const __vue_module_identifier__$4 = undefined;
      /* functional template */
      const __vue_is_functional_template__$4 = false;
      /* style inject SSR */
      

      
      var InsertDialog = normalizeComponent_1(
        { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
        __vue_inject_styles__$4,
        __vue_script__$4,
        __vue_scope_id__$4,
        __vue_is_functional_template__$4,
        __vue_module_identifier__$4,
        browser,
        undefined
      );

    //
    var script$5 = {
      name: 'InsertMenu',
      components: {
        InsertDialog: InsertDialog,
        EditorButton: editorCore.EditorButton,
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        quick: function quick() {
          return this.menu.quickItems();
        }
      },
      data: function data() {
        return {
          left: 0,
          isActive: false,
          top: 0,
          collapsed: false
        };
      },
      mounted: function mounted() {
        var _this = this;

        this.$editor.$on('selection', this.onSelection);
        this.$nextTick(function () {
          _this.onSelection(new structuredEditor.SelectionEvent(_this.$editor.tiptap.view));
        });
      },
      beforeDestroy: function beforeDestroy() {
        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        /**
         *
         * @param {SelectionEvent} selection
         */
        onSelection: function onSelection(selection) {
          var _this2 = this;

          var state = selection.view.state;
          var currentDom = selection.view.domAtPos(state.selection.$anchor.pos);
          this.isActive = currentDom.node.innerHTML === '<br>' && currentDom.node.tagName === 'P';

          if (this.isActive) {
            var ownerPos = currentDom.node.getBoundingClientRect();
            this.collapsed = false;

            if (this.menu.settings.collapse && currentDom.node.offsetWidth <= this.menu.settings.collapse) {
              this.collapsed = true;
            }

            var parent = this.$editor.$el.parentNode;
            var editorBounds = parent.getBoundingClientRect();
            var cursorBounds = selection.view.coordsAtPos(state.selection.$anchor.pos);
            this.top = cursorBounds.top - editorBounds.top;
            this.$nextTick(function () {
              _this2.left = ownerPos.x - editorBounds.x + currentDom.node.offsetWidth - _this2.$el.offsetWidth;
            });
          }
        }
      }
    };

    /* script */
    const __vue_script__$5 = script$5;

    /* template */
    var __vue_render__$5 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          staticClass: "lede-insert-menu",
          style: { top: _vm.top + "px", left: _vm.left + "px" }
        },
        [
          _vm.isActive
            ? _c(
                "div",
                { staticClass: "menu-inner" },
                [
                  _vm._l(_vm.quick, function(item, idx) {
                    return !_vm.collapsed
                      ? [
                          _c("menu-item", {
                            key: idx,
                            attrs: { item: item, editor: _vm.editor }
                          })
                        ]
                      : _vm._e()
                  }),
                  _vm._v(" "),
                  _c("insert-dialog", {
                    attrs: { menu: _vm.menu, editor: _vm.editor }
                  })
                ],
                2
              )
            : _vm._e()
        ]
      )
    };
    var __vue_staticRenderFns__$5 = [];
    __vue_render__$5._withStripped = true;

      /* style */
      const __vue_inject_styles__$5 = function (inject) {
        if (!inject) return
        inject("data-v-0a849362_0", { source: ".lede-insert-menu {\n  position: absolute;\n  display: inline-block;\n  z-index: 10;\n}\n.lede-insert-menu .menu-inner {\n  display: flex;\n}\n\n/*# sourceMappingURL=InsertMenu.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\InsertMenu.vue","InsertMenu.vue"],"names":[],"mappings":"AAqGA;EACA,kBAAA;EACA,qBAAA;EAEA,WAAA;ACrGA;ADyGA;EACA,aAAA;ACvGA;;AAEA,yCAAyC","file":"InsertMenu.vue","sourcesContent":["<template>\r\n    <div class=\"lede-insert-menu\" :style=\"{top: top + 'px', left: left+ 'px'}\">\r\n        <div class=\"menu-inner\" v-if=\"isActive\">\r\n            <template v-if=\"!collapsed\" v-for=\"(item, idx) in quick\">\r\n                <menu-item :item=\"item\" :key=\"idx\" :editor=\"editor\"></menu-item>\r\n            </template>\r\n            <insert-dialog :menu=\"menu\" :editor=\"editor\"></insert-dialog>\r\n        </div>\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n    import MenuItem from './MenuItem.vue'\r\n    import {EditorButton} from '@ledecmf/editor-core'\r\n    import {SelectionEvent} from '@ledecmf/structured-editor'\r\n    import InsertDialog from './InsertDialog.vue'\r\n\r\n    export default {\r\n        name: 'InsertMenu',\r\n        components: {InsertDialog, EditorButton, MenuItem},\r\n        provide() {\r\n            return {\r\n                '$menu': this,\r\n            }\r\n        },\r\n\r\n        inject: ['$editor'],\r\n        props: {\r\n            menu: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            editor: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n        },\r\n        computed: {\r\n\r\n            quick() {\r\n                return this.menu.quickItems()\r\n            },\r\n        },\r\n\r\n        data() {\r\n            return {\r\n                left: 0,\r\n                isActive: false,\r\n                top: 0,\r\n                collapsed: false\r\n\r\n            }\r\n        },\r\n\r\n        mounted() {\r\n\r\n            this.$editor.$on('selection', this.onSelection)\r\n            this.$nextTick(() => {\r\n                this.onSelection(new SelectionEvent(this.$editor.tiptap.view))\r\n            })\r\n        },\r\n\r\n        beforeDestroy() {\r\n\r\n            this.$editor.$off('selection', this.onSelection)\r\n        },\r\n\r\n        methods: {\r\n            /**\r\n             *\r\n             * @param {SelectionEvent} selection\r\n             */\r\n            onSelection(selection) {\r\n                const state = selection.view.state\r\n\r\n                const currentDom = selection.view.domAtPos(state.selection.$anchor.pos)\r\n                this.isActive = currentDom.node.innerHTML === '<br>'\r\n                    && currentDom.node.tagName === 'P'\r\n\r\n                if (this.isActive) {\r\n                    let ownerPos = currentDom.node.getBoundingClientRect();\r\n                    this.collapsed = false;\r\n                            if (this.menu.settings.collapse &&  currentDom.node.offsetWidth <= this.menu.settings.collapse) {\r\n                        this.collapsed = true;\r\n                    }\r\n                    let parent = this.$editor.$el.parentNode;\r\n                    const editorBounds = parent.getBoundingClientRect()\r\n                    const cursorBounds = selection.view.coordsAtPos(state.selection.$anchor.pos)\r\n                    this.top = cursorBounds.top - editorBounds.top\r\n                    this.$nextTick(() => {\r\n                        this.left = (ownerPos.x  - editorBounds.x) + currentDom.node.offsetWidth - this.$el.offsetWidth;\r\n                    })\r\n                }\r\n\r\n            },\r\n        },\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n    .lede-insert-menu {\r\n        position: absolute;\r\n        display: inline-block;\r\n\r\n        z-index: 10;\r\n\r\n\r\n\r\n        .menu-inner {\r\n            display: flex;\r\n        }\r\n    }\r\n</style>\r\n",".lede-insert-menu {\n  position: absolute;\n  display: inline-block;\n  z-index: 10;\n}\n.lede-insert-menu .menu-inner {\n  display: flex;\n}\n\n/*# sourceMappingURL=InsertMenu.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$5 = undefined;
      /* module identifier */
      const __vue_module_identifier__$5 = undefined;
      /* functional template */
      const __vue_is_functional_template__$5 = false;
      /* style inject SSR */
      

      
      var InsertMenu = normalizeComponent_1(
        { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
        __vue_inject_styles__$5,
        __vue_script__$5,
        __vue_scope_id__$5,
        __vue_is_functional_template__$5,
        __vue_module_identifier__$5,
        browser,
        undefined
      );

    //
    var script$6 = {
      name: 'MenuDropButton',
      components: {
        EditorButton: editorCore.EditorButton
      },
      directives: {
        clickOutside: vClickOutside.directive
      },
      inject: ['$menu', '$editor'],
      props: {
        item: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        showLabel: Boolean
      },
      data: function data() {
        return {
          opened: false,
          fromMenu: false
        };
      },
      beforeDestroy: function beforeDestroy() {
        this.destroyPopper();
      },
      methods: {
        destroyPopper: function destroyPopper() {
          if (this.popper) {
            this.popper.destroy();
            this.popper = null;
          }
        },
        open: function open() {
          var _this = this;

          if (this.$editor.showMenu) {
            this.fromMenu = true;
            this.destroyPopper();
            this.$nextTick(function () {
              _this.popper = new Popper(_this.$el, _this.$refs.body, {
                'placement': 'bottom'
              });
            });
          } else {
            this.$menu.showOnly(this.item);
            this.fromMenu = false;
          }

          this.opened = true;
          this.$emit('opened');
        },
        close: function close() {
          if (this.$editor.showMenu) {
            this.destroyPopper();
          } else {
            this.$menu.showOnly();
          }

          this.opened = false;
          this.$emit('closed');
        },
        toggle: function toggle() {
          if (this.opened) {
            this.close();
          } else {
            this.open();
          }
        }
      }
    };

    /* script */
    const __vue_script__$6 = script$6;

    /* template */
    var __vue_render__$6 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        { staticClass: "menu-drop-button", class: { "from-menu": _vm.fromMenu } },
        [
          _c("editor-button", {
            ref: "button",
            attrs: {
              label: _vm.item.label,
              "show-label": _vm.showLabel,
              icon: _vm.item.icon
            },
            on: { click: _vm.toggle }
          }),
          _vm._v(" "),
          _c("div", { ref: "body", staticClass: "button-body" }, [
            _vm.opened
              ? _c(
                  "div",
                  {
                    directives: [
                      {
                        name: "click-outside",
                        rawName: "v-click-outside",
                        value: _vm.close,
                        expression: "close"
                      }
                    ]
                  },
                  [
                    _vm._t("default"),
                    _vm._v(" "),
                    _vm.fromMenu
                      ? _c("div", { attrs: { "x-arrow": "" } })
                      : _vm._e()
                  ],
                  2
                )
              : _vm._e()
          ])
        ],
        1
      )
    };
    var __vue_staticRenderFns__$6 = [];
    __vue_render__$6._withStripped = true;

      /* style */
      const __vue_inject_styles__$6 = function (inject) {
        if (!inject) return
        inject("data-v-57b1ffdb_0", { source: "\n\n/*# sourceMappingURL=MenuDropButton.vue.map */", map: {"version":3,"sources":["MenuDropButton.vue"],"names":[],"mappings":";;AAEA,6CAA6C","file":"MenuDropButton.vue"}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$6 = undefined;
      /* module identifier */
      const __vue_module_identifier__$6 = undefined;
      /* functional template */
      const __vue_is_functional_template__$6 = false;
      /* style inject SSR */
      

      
      var MenuDropButton = normalizeComponent_1(
        { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
        __vue_inject_styles__$6,
        __vue_script__$6,
        __vue_scope_id__$6,
        __vue_is_functional_template__$6,
        __vue_module_identifier__$6,
        browser,
        undefined
      );

    //
    //
    //
    //
    var script$7 = {
      name: 'MenuSeparator'
    };

    /* script */
    const __vue_script__$7 = script$7;

    /* template */
    var __vue_render__$7 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c("div", { staticClass: "menu-separator" })
    };
    var __vue_staticRenderFns__$7 = [];
    __vue_render__$7._withStripped = true;

      /* style */
      const __vue_inject_styles__$7 = function (inject) {
        if (!inject) return
        inject("data-v-3b9bc78e_0", { source: "\n\n\n\n\n\n\n\n\n\n\n\n", map: {"version":3,"sources":[],"names":[],"mappings":"","file":"MenuSeparator.vue"}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$7 = "data-v-3b9bc78e";
      /* module identifier */
      const __vue_module_identifier__$7 = undefined;
      /* functional template */
      const __vue_is_functional_template__$7 = false;
      /* style inject SSR */
      

      
      var MenuSeparator = normalizeComponent_1(
        { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
        __vue_inject_styles__$7,
        __vue_script__$7,
        __vue_scope_id__$7,
        __vue_is_functional_template__$7,
        __vue_module_identifier__$7,
        browser,
        undefined
      );

    //
    var script$8 = {
      name: 'SelectionMenu',
      components: {
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      watch: {
        active: function active(val) {
          if (this.popper && !val) {
            this.popper.destroy();
            this.popper = null;
          }
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          active: false,
          style: {},
          only: null
        };
      },
      mounted: function mounted() {
        this.showDebounce = null;
        this.$editor.$on('selection', this.onSelection);
      },
      beforeDestroy: function beforeDestroy() {
        this.hide();

        if (this.showDebounce) {
          clearTimeout(this.showDebounce);
        }

        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        showOnly: function showOnly(item) {
          var _this = this;

          this.only = item;
          this.$nextTick(function () {
            if (_this.popper) {
              _this.popper.update();
            }
          });
        },
        onSelection: function onSelection(selection) {
          var _this2 = this;

          if (this.showDebounce) {
            clearTimeout(this.showDebounce);
          }

          this.hide();

          if (!selection.empty && (selection.type === 'text' || selection.type === 'node' && selection.node.type.isInline)) {
            this.showDebounce = setTimeout(function () {
              if (!selection.empty) {
                _this2.show(selection);
              }
            }, 100);
          }
        },
        hide: function hide() {
          this.active = false;
          document.removeEventListener('mousedown', this.maybeHide);
          this.only = null;
        },
        maybeHide: function maybeHide(event) {
          if (!this.$el.contains(event.target)) {
            this.hide();
          }
        },
        show: function show(selection) {
          var _this3 = this;

          document.addEventListener('mousedown', this.maybeHide);
          this.active = true;
          var parent = this.$editor.$el;
          var box = parent.getBoundingClientRect();
          var left = 0,
              bottom = 0;
          left = Math.max((selection.box.start.left + selection.box.end.left) / 2, selection.box.start.left + 3);
          left = parseInt(left - box.left, 10);
          bottom = selection.box.start.top;
          this.style = {
            left: left + 'px',
            bottom: parseInt(box.bottom - bottom, 10) + 'px'
          };
          this.$nextTick(function () {
            var anchor = _this3.$refs.marker;
            _this3.popper = new Popper(anchor, _this3.$refs.menu, {
              placement: 'top',
              offset: 0
            }); //  document.addEventListener('mousedown', this.checkMouse);
          });
        }
      }
    };

    /* script */
    const __vue_script__$8 = script$8;

    /* template */
    var __vue_render__$8 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c("div", { staticClass: "lede-selection-menu", style: _vm.style }, [
        _c("div", { ref: "marker", staticClass: "selection-marker" }),
        _vm._v(" "),
        _vm.active
          ? _c(
              "div",
              { ref: "menu", staticClass: "menu-inner" },
              [
                _vm._l(_vm.items, function(item, idx) {
                  return [
                    !_vm.only || _vm.only === item
                      ? _c("menu-item", {
                          key: idx,
                          attrs: { item: item, editor: _vm.editor }
                        })
                      : _vm._e()
                  ]
                }),
                _vm._v(" "),
                _c("div", { staticClass: "menu-arrow", attrs: { "x-arrow": "" } })
              ],
              2
            )
          : _vm._e()
      ])
    };
    var __vue_staticRenderFns__$8 = [];
    __vue_render__$8._withStripped = true;

      /* style */
      const __vue_inject_styles__$8 = function (inject) {
        if (!inject) return
        inject("data-v-593c1c42_0", { source: ".lede-selection-menu {\n  position: absolute;\n  z-index: 100;\n}\n.lede-selection-menu .selection-marker {\n  position: absolute;\n  width: 0;\n  height: 0;\n}\n.lede-selection-menu .menu-inner {\n  display: inline-flex;\n  border-radius: 4px;\n}\n.lede-selection-menu button {\n  display: inline-flex;\n  align-items: center;\n  padding: 5px;\n}\n.menu-drop-button {\n  display: flex;\n}\n.menu-drop-button .button-body {\n  display: flex;\n}\n\n/*# sourceMappingURL=SelectionMenu.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\SelectionMenu.vue","SelectionMenu.vue"],"names":[],"mappings":"AAqJA;EACA,kBAAA;EACA,YAAA;ACpJA;ADqJA;EACA,kBAAA;EACA,QAAA;EACA,SAAA;ACnJA;ADsJA;EACA,oBAAA;EACA,kBAAA;ACpJA;ADuJA;EACA,oBAAA;EACA,mBAAA;EACA,YAAA;ACrJA;ADyJA;EACA,aAAA;ACtJA;ADuJA;EACA,aAAA;ACrJA;;AAEA,4CAA4C","file":"SelectionMenu.vue","sourcesContent":["<template>\r\n    <div class=\"lede-selection-menu\" :style=\"style\">\r\n\r\n        <div class=\"selection-marker\" ref=\"marker\"></div>\r\n        <div class=\"menu-inner\" v-if=\"active\" ref=\"menu\">\r\n            <template v-for=\"(item, idx) in items\">\r\n                <menu-item v-if=\"!only || only === item\" :item=\"item\" :key=\"idx\" :editor=\"editor\"></menu-item>\r\n            </template>\r\n            <div class=\"menu-arrow\" x-arrow></div>\r\n        </div>\r\n\r\n    </div>\r\n</template>\r\n<script>\r\n    import Popper from 'popper.js'\r\n    import MenuItem from './MenuItem.vue'\r\n    import { findDomRefAtPos } from 'prosemirror-utils';\r\n\r\n    export default {\r\n        name: 'SelectionMenu',\r\n        components: {MenuItem},\r\n        provide() {\r\n            return {\r\n                '$menu': this,\r\n            }\r\n        },\r\n\r\n        inject: ['$editor'],\r\n        props: {\r\n            menu: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            editor: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n        },\r\n\r\n        watch: {\r\n            active(val) {\r\n                if (this.popper && !val) {\r\n                    this.popper.destroy()\r\n                    this.popper = null\r\n                }\r\n            },\r\n        },\r\n\r\n        computed: {\r\n            items() {\r\n                return this.menu.all()\r\n            },\r\n        },\r\n\r\n        data() {\r\n            return {\r\n                active: false,\r\n                style: {},\r\n                only: null,\r\n            }\r\n        },\r\n\r\n        mounted() {\r\n            this.showDebounce = null\r\n            this.$editor.$on('selection', this.onSelection)\r\n        },\r\n\r\n        beforeDestroy() {\r\n            this.hide()\r\n            if (this.showDebounce) {\r\n                clearTimeout(this.showDebounce)\r\n            }\r\n            this.$editor.$off('selection', this.onSelection)\r\n        },\r\n\r\n        methods: {\r\n\r\n            showOnly(item) {\r\n                this.only = item\r\n                this.$nextTick(() => {\r\n                    if(this.popper) {\r\n                        this.popper.update();\r\n                    }\r\n                })\r\n            },\r\n\r\n            onSelection(selection) {\r\n\r\n                if (this.showDebounce) {\r\n                    clearTimeout(this.showDebounce)\r\n                }\r\n                this.hide()\r\n                if (!selection.empty && (selection.type === 'text' || (selection.type === 'node' && selection.node.type.isInline))) {\r\n                    this.showDebounce = setTimeout(() => {\r\n                        if (!selection.empty) {\r\n                            this.show(selection)\r\n                        }\r\n                    }, 100)\r\n                }\r\n            },\r\n\r\n            hide() {\r\n\r\n                this.active = false\r\n                document.removeEventListener('mousedown', this.maybeHide)\r\n                this.only = null;\r\n            },\r\n\r\n            maybeHide(event) {\r\n                if (!this.$el.contains(event.target)) {\r\n                    this.hide()\r\n\r\n                }\r\n            },\r\n            show(selection) {\r\n                document.addEventListener('mousedown', this.maybeHide)\r\n                this.active = true\r\n                let parent = this.$editor.$el\r\n                const box = parent.getBoundingClientRect()\r\n                let left = 0, bottom = 0\r\n\r\n                left = Math.max((selection.box.start.left + selection.box.end.left) / 2, selection.box.start.left + 3)\r\n                left = parseInt(left - box.left, 10)\r\n                bottom = selection.box.start.top\r\n\r\n                this.style = {\r\n                    left: left + 'px',\r\n                    bottom: parseInt(box.bottom - bottom, 10) + 'px',\r\n                }\r\n\r\n                this.$nextTick(() => {\r\n                    let anchor = this.$refs.marker;\r\n\r\n                    this.popper = new Popper(anchor, this.$refs.menu, {\r\n                        placement: 'top',\r\n                        offset: 0,\r\n                    })\r\n\r\n                    //  document.addEventListener('mousedown', this.checkMouse);\r\n                })\r\n            },\r\n\r\n        },\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n\r\n    .lede-selection-menu {\r\n        position: absolute;\r\n        z-index: 100;\r\n        .selection-marker {\r\n            position: absolute;\r\n            width:0;\r\n            height: 0;\r\n        }\r\n\r\n        .menu-inner {\r\n            display: inline-flex;\r\n            border-radius: 4px;\r\n        }\r\n\r\n        button {\r\n            display: inline-flex;\r\n            align-items: center;\r\n            padding: 5px;\r\n        }\r\n    }\r\n\r\n    .menu-drop-button {\r\n        display: flex;\r\n        .button-body {\r\n            display: flex;\r\n        }\r\n    }\r\n\r\n</style>\r\n",".lede-selection-menu {\n  position: absolute;\n  z-index: 100;\n}\n.lede-selection-menu .selection-marker {\n  position: absolute;\n  width: 0;\n  height: 0;\n}\n.lede-selection-menu .menu-inner {\n  display: inline-flex;\n  border-radius: 4px;\n}\n.lede-selection-menu button {\n  display: inline-flex;\n  align-items: center;\n  padding: 5px;\n}\n\n.menu-drop-button {\n  display: flex;\n}\n.menu-drop-button .button-body {\n  display: flex;\n}\n\n/*# sourceMappingURL=SelectionMenu.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$8 = undefined;
      /* module identifier */
      const __vue_module_identifier__$8 = undefined;
      /* functional template */
      const __vue_is_functional_template__$8 = false;
      /* style inject SSR */
      

      
      var SelectionMenu = normalizeComponent_1(
        { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
        __vue_inject_styles__$8,
        __vue_script__$8,
        __vue_scope_id__$8,
        __vue_is_functional_template__$8,
        __vue_module_identifier__$8,
        browser,
        undefined
      );

    //

    function addMenuItems(items, newItems) {
      var labels = [];
      items.forEach(function (item) {
        labels.push(item.label + item.icon);
      });
      newItems.forEach(function (item) {
        if (labels.indexOf(item.label + item.icon) < 0) {
          items.push(item);
        }
      });
      return items;
    }

    var script$9 = {
      name: 'MenuBar',
      components: {
        MenuSeparator: MenuSeparator,
        InsertDialog: InsertDialog,
        MenuItem: MenuItem
      },
      inject: ['$editor'],
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      props: {
        config: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        settings: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          var items = [];
          items = addMenuItems(items, this.config.selectionMenu.all());
          items.push('divider');
          items = addMenuItems(items, this.config.insertMenu.quickItems());
          items.push('insert-dialog');
          items = addMenuItems(items, this.config.blockMenu.all());
          return items;
        },
        width: function width() {
          if (this.isStuck) {
            return this.$el.getBoundingClientRect().width + 'px';
          }

          return '100%';
        }
      },
      watch: {
        isStuck: function isStuck(val, oldVal) {
          if (val) {
            this.$editor.$el.style['padding-top'] = this.$el.clientHeight + 'px';
          } else {
            this.$editor.$el.style['padding-top'] = 0;
          }
        }
      },
      data: function data() {
        return {
          isStuck: false
        };
      },
      mounted: function mounted() {
        var el = typeof this.settings.scrollElement === 'string' ? document.querySelector(this.settings.scrollElement) : this.settings.scrollElement;
        el.addEventListener('scroll', this.watchScroll);
      },
      methods: {
        watchScroll: function watchScroll(e) {
          if (this.$editor.$el.getBoundingClientRect().top < this.settings.offset) {
            this.isStuck = true;
          } else {
            this.isStuck = false;
          }
        }
      }
    };

    /* script */
    const __vue_script__$9 = script$9;

    /* template */
    var __vue_render__$9 = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          staticClass: "lede-editor-menu-bar",
          class: { "is-stuck": _vm.isStuck },
          style: {
            top: _vm.isStuck ? _vm.settings.offset + "px" : "auto",
            width: _vm.width
          }
        },
        [
          _c(
            "div",
            { ref: "menu", staticClass: "menu-inner" },
            [
              _vm._l(_vm.items, function(item, idx) {
                return [
                  item === "divider"
                    ? _c("menu-separator")
                    : item === "insert-dialog"
                    ? _c("insert-dialog", {
                        attrs: { menu: _vm.config.insertMenu, editor: _vm.editor }
                      })
                    : _c("menu-item", {
                        key: idx,
                        attrs: { item: item, editor: _vm.editor }
                      })
                ]
              })
            ],
            2
          )
        ]
      )
    };
    var __vue_staticRenderFns__$9 = [];
    __vue_render__$9._withStripped = true;

      /* style */
      const __vue_inject_styles__$9 = function (inject) {
        if (!inject) return
        inject("data-v-7dee012b_0", { source: ".lede-editor-menu-bar.is-stuck {\n  position: fixed;\n}\n.lede-editor-menu-bar .menu-inner {\n  display: flex;\n  flex-wrap: wrap;\n  align-items: center;\n}\n.lede-editor-menu-bar .menu-arrow {\n  display: none;\n}\n.lede-editor-menu-bar select {\n  border-radius: 0.25rem;\n  padding: 0;\n  height: 28px;\n}\n\n/*# sourceMappingURL=MenuBar.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\MenuBar.vue","MenuBar.vue"],"names":[],"mappings":"AAsHA;EACA,eAAA;ACrHA;ADwHA;EACA,aAAA;EACA,eAAA;EACA,mBAAA;ACtHA;ADyHA;EACA,aAAA;ACvHA;AD0HA;EACA,sBAAA;EACA,UAAA;EACA,YAAA;ACxHA;;AAEA,sCAAsC","file":"MenuBar.vue","sourcesContent":["<template>\r\n    <div class=\"lede-editor-menu-bar\" :class=\"{'is-stuck' : isStuck}\"\r\n         :style=\"{top: isStuck ? settings.offset + 'px' : 'auto', width: width}\">\r\n        <div class=\"menu-inner\" ref=\"menu\">\r\n            <template v-for=\"(item, idx) in items\">\r\n                <menu-separator v-if=\"item==='divider'\"></menu-separator>\r\n                <insert-dialog v-else-if=\"item === 'insert-dialog'\" :menu=\"config.insertMenu\" :editor=\"editor\"></insert-dialog>\r\n                <menu-item v-else :item=\"item\" :key=\"idx\" :editor=\"editor\"></menu-item>\r\n            </template>\r\n        </div>\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n    import MenuItem from './MenuItem.vue'\r\n    import InsertDialog from './InsertDialog.vue'\r\n    import MenuSeparator from './MenuSeparator.vue'\r\n\r\n    function addMenuItems(items, newItems) {\r\n        let labels = [];\r\n        items.forEach((item) => {\r\n            labels.push(item.label + item.icon);\r\n        })\r\n\r\n        newItems.forEach((item) => {\r\n            if (labels.indexOf(item.label + item.icon) < 0) {\r\n                items.push(item)\r\n            }\r\n\r\n        })\r\n        return items\r\n    }\r\n\r\n    export default {\r\n        name: 'MenuBar',\r\n        components: {\r\n            MenuSeparator,\r\n            InsertDialog, MenuItem},\r\n        inject: ['$editor'],\r\n        provide() {\r\n            return {\r\n                '$menu': this,\r\n            }\r\n        },\r\n        props: {\r\n            config: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            editor: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n\r\n            settings: {\r\n                type: Object,\r\n                required: true,\r\n            },\r\n        },\r\n\r\n        computed: {\r\n            items() {\r\n                let items = []\r\n                items = addMenuItems(items, this.config.selectionMenu.all())\r\n                items.push('divider')\r\n                items = addMenuItems(items, this.config.insertMenu.quickItems())\r\n                items.push('insert-dialog')\r\n                items = addMenuItems(items, this.config.blockMenu.all())\r\n                return items\r\n\r\n            },\r\n            width() {\r\n                if (this.isStuck) {\r\n                    return this.$el.getBoundingClientRect().width + 'px'\r\n                }\r\n                return '100%'\r\n            },\r\n        },\r\n\r\n        watch: {\r\n            isStuck(val, oldVal) {\r\n                if (val) {\r\n                    this.$editor.$el.style['padding-top'] = this.$el.clientHeight + 'px'\r\n                } else {\r\n                    this.$editor.$el.style['padding-top'] = 0\r\n                }\r\n            },\r\n        },\r\n\r\n        data() {\r\n            return {\r\n                isStuck: false,\r\n\r\n            }\r\n        },\r\n\r\n        mounted() {\r\n            let el = typeof this.settings.scrollElement === 'string' ? document.querySelector(\r\n                this.settings.scrollElement) : this.settings.scrollElement\r\n            el.addEventListener('scroll', this.watchScroll)\r\n        },\r\n\r\n        methods: {\r\n            watchScroll(e) {\r\n                if (this.$editor.$el.getBoundingClientRect().top < this.settings.offset) {\r\n                    this.isStuck = true\r\n                } else {\r\n                    this.isStuck = false\r\n                }\r\n\r\n            },\r\n        },\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n    .lede-editor-menu-bar {\r\n        &.is-stuck {\r\n            position: fixed;\r\n        }\r\n\r\n        .menu-inner {\r\n            display: flex;\r\n            flex-wrap: wrap;\r\n            align-items: center;\r\n        }\r\n\r\n        .menu-arrow {\r\n            display: none;\r\n        }\r\n\r\n        select {\r\n            border-radius: .25rem;\r\n            padding: 0;\r\n            height: 28px;\r\n        }\r\n    }\r\n</style>\r\n",".lede-editor-menu-bar.is-stuck {\n  position: fixed;\n}\n.lede-editor-menu-bar .menu-inner {\n  display: flex;\n  flex-wrap: wrap;\n  align-items: center;\n}\n.lede-editor-menu-bar .menu-arrow {\n  display: none;\n}\n.lede-editor-menu-bar select {\n  border-radius: 0.25rem;\n  padding: 0;\n  height: 28px;\n}\n\n/*# sourceMappingURL=MenuBar.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$9 = undefined;
      /* module identifier */
      const __vue_module_identifier__$9 = undefined;
      /* functional template */
      const __vue_is_functional_template__$9 = false;
      /* style inject SSR */
      

      
      var MenuBar = normalizeComponent_1(
        { render: __vue_render__$9, staticRenderFns: __vue_staticRenderFns__$9 },
        __vue_inject_styles__$9,
        __vue_script__$9,
        __vue_scope_id__$9,
        __vue_is_functional_template__$9,
        __vue_module_identifier__$9,
        browser,
        undefined
      );

    //
    var script$a = {
      name: 'NodeResizer',
      props: {
        enabled: {
          type: Boolean,
          default: false
        },
        min: {
          type: Number
        },
        max: {
          type: Number
        }
      },
      data: function data() {
        return {
          sides: ['top', 'right', 'bottom', 'left'],
          resizing: false
        };
      },
      methods: {
        startResize: function startResize(e) {
          this.startPos = event.x;
          this.width = parseInt(getComputedStyle(this.$el).width);
          editorCore.addEvent(document.documentElement, 'mousemove', this.doDrag);
          editorCore.addEvent(document.documentElement, 'mouseup', this.stopDrag);
          this.resizing = true;
          this.$emit('resizeStart');
        },
        stop: function stop() {
          var _this = this;

          editorCore.removeEvent(document.documentElement, 'mousemove', this.doDrag);
          editorCore.removeEvent(document.documentElement, 'mouseup', this.stopDrag);
          this.$nextTick(function () {
            _this.resizing = false;

            _this.$emit('resize-stop');
          });
        },
        doDrag: function doDrag(event) {
          var dx = this.startPos - event.x;
          var newSize = this.width + dx;

          if (this.min && newSize < this.min) {
            return;
          }

          if (this.max && newSize > this.max) {
            return;
          }

          this.$emit('update', newSize);
        },
        stopDrag: function stopDrag(event) {
          this.stop();
        }
      }
    };

    /* script */
    const __vue_script__$a = script$a;

    /* template */
    var __vue_render__$a = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        { staticClass: "lede-node-resizer" },
        [
          _vm._t("default"),
          _vm._v(" "),
          _vm.enabled
            ? _vm._l(_vm.sides, function(side) {
                return _c("div", {
                  staticClass: "resize-handle",
                  class: "resize-handle-" + side,
                  on: {
                    mousedown: function($event) {
                      $event.stopPropagation();
                      $event.preventDefault();
                      return _vm.startResize($event)
                    }
                  }
                })
              })
            : _vm._e()
        ],
        2
      )
    };
    var __vue_staticRenderFns__$a = [];
    __vue_render__$a._withStripped = true;

      /* style */
      const __vue_inject_styles__$a = function (inject) {
        if (!inject) return
        inject("data-v-89459bde_0", { source: ".lede-node-resizer {\n  position: relative;\n}\n.lede-node-resizer .resize-handle {\n  width: 18px;\n  height: 18px;\n  position: absolute;\n  border-radius: 50%;\n  background: #4f8aff;\n  border: 2px solid #fff;\n}\n.lede-node-resizer .resize-handle.resize-handle-left {\n  left: -9px;\n  top: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-right {\n  right: -9px;\n  top: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-top {\n  top: -9px;\n  left: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-bottom {\n  bottom: -9px;\n  left: 50%;\n}\n\n/*# sourceMappingURL=NodeResizer.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\NodeResizer.vue","NodeResizer.vue"],"names":[],"mappings":"AA+EA;EACA,kBAAA;AC9EA;ADgFA;EACA,WAAA;EACA,YAAA;EACA,kBAAA;EACA,kBAAA;EACA,mBAAA;EACA,sBAAA;AC9EA;ADgFA;EACA,UAAA;EACA,QAAA;AC9EA;ADiFA;EACA,WAAA;EACA,QAAA;AC/EA;ADkFA;EACA,SAAA;EACA,SAAA;AChFA;ADmFA;EACA,YAAA;EACA,SAAA;ACjFA;;AAEA,0CAA0C","file":"NodeResizer.vue","sourcesContent":["<template>\n    <div class=\"lede-node-resizer\">\n        <slot></slot>\n\n        <template v-if=\"enabled\">\n            <div v-for=\"side in sides\" class=\"resize-handle\" :class=\"'resize-handle-' + side\"\n                 @mousedown.stop.prevent=\"startResize\"\n            ></div>\n        </template>\n\n    </div>\n</template>\n\n<script>\n    import {addEvent, removeEvent} from '@ledecmf/editor-core'\n\n    export default {\n        name: 'NodeResizer',\n        props: {\n            enabled: {\n                type: Boolean,\n                default: false,\n            },\n            min: {\n                type: Number,\n            },\n            max: {\n                type: Number\n            }\n        },\n\n        data() {\n            return {\n                sides: ['top', 'right', 'bottom', 'left'],\n                resizing: false,\n            }\n        },\n\n        methods: {\n            startResize(e) {\n                this.startPos = event.x\n                this.width = parseInt(getComputedStyle(this.$el).width)\n                addEvent(document.documentElement, 'mousemove', this.doDrag)\n                addEvent(document.documentElement, 'mouseup', this.stopDrag)\n                this.resizing = true\n                this.$emit('resizeStart')\n            },\n            stop() {\n\n                removeEvent(document.documentElement, 'mousemove', this.doDrag)\n                removeEvent(document.documentElement, 'mouseup', this.stopDrag)\n                this.$nextTick(() => {\n                    this.resizing = false\n                    this.$emit('resize-stop')\n                })\n\n            },\n\n            doDrag(event) {\n                const dx = this.startPos - event.x\n                let newSize = this.width + dx\n                if (this.min && newSize < this.min) {\n                    return\n                }\n\n                if (this.max && newSize>this.max) {\n                    return;\n                }\n                this.$emit('update', newSize)\n            },\n\n            stopDrag(event) {\n                this.stop()\n            },\n        },\n    }\n</script>\n\n<style lang=\"scss\">\n    .lede-node-resizer {\n        position: relative;\n\n        .resize-handle {\n            width: 18px;\n            height: 18px;\n            position: absolute;\n            border-radius: 50%;\n            background: #4f8aff;\n            border: 2px solid #fff;\n\n            &.resize-handle-left {\n                left: -9px;\n                top: 50%;\n            }\n\n            &.resize-handle-right {\n                right: -9px;\n                top: 50%;\n            }\n\n            &.resize-handle-top {\n                top: -9px;\n                left: 50%;\n            }\n\n            &.resize-handle-bottom {\n                bottom: -9px;\n                left: 50%;\n            }\n        }\n    }\n</style>\n",".lede-node-resizer {\n  position: relative;\n}\n.lede-node-resizer .resize-handle {\n  width: 18px;\n  height: 18px;\n  position: absolute;\n  border-radius: 50%;\n  background: #4f8aff;\n  border: 2px solid #fff;\n}\n.lede-node-resizer .resize-handle.resize-handle-left {\n  left: -9px;\n  top: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-right {\n  right: -9px;\n  top: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-top {\n  top: -9px;\n  left: 50%;\n}\n.lede-node-resizer .resize-handle.resize-handle-bottom {\n  bottom: -9px;\n  left: 50%;\n}\n\n/*# sourceMappingURL=NodeResizer.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$a = undefined;
      /* module identifier */
      const __vue_module_identifier__$a = undefined;
      /* functional template */
      const __vue_is_functional_template__$a = false;
      /* style inject SSR */
      

      
      var NodeResizer = normalizeComponent_1(
        { render: __vue_render__$a, staticRenderFns: __vue_staticRenderFns__$a },
        __vue_inject_styles__$a,
        __vue_script__$a,
        __vue_scope_id__$a,
        __vue_is_functional_template__$a,
        __vue_module_identifier__$a,
        browser,
        undefined
      );

    //
    var script$b = {
      name: 'NodeOptions',
      components: {
        NodeResizer: NodeResizer,
        EditorButton: editorCore.EditorButton
      },
      props: {
        selected: Boolean,
        value: {
          type: String
        },
        options: {
          type: Object
        }
      },
      computed: {
        notAligned: function notAligned() {
          return this.value !== 'left' && this.value !== 'right' && this.value !== 'center';
        }
      }
    };

    /* script */
    const __vue_script__$b = script$b;

    /* template */
    var __vue_render__$b = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          staticClass: "node-has-options",
          class: { "is-selected": _vm.selected },
          attrs: { "lede-align": _vm.value }
        },
        [
          _c(
            "div",
            { staticClass: "options-inner" },
            [
              _vm._t("default"),
              _vm._v(" "),
              _vm.selected
                ? _c(
                    "div",
                    { staticClass: "node-options" },
                    [
                      _vm.options
                        ? [
                            !_vm.notAligned
                              ? _c("editor-button", {
                                  attrs: {
                                    icon: "align_justify",
                                    label: "Align none"
                                  },
                                  on: {
                                    click: function($event) {
                                      return _vm.$emit("input", "")
                                    }
                                  }
                                })
                              : _vm._e(),
                            _vm._v(" "),
                            _vm.value !== "left"
                              ? _c("editor-button", {
                                  attrs: {
                                    icon: "align_left",
                                    label: "Align left"
                                  },
                                  on: {
                                    click: function($event) {
                                      return _vm.$emit("input", "left")
                                    }
                                  }
                                })
                              : _vm._e(),
                            _vm._v(" "),
                            _vm.value !== "center"
                              ? _c("editor-button", {
                                  attrs: {
                                    icon: "align_center",
                                    label: "Align center"
                                  },
                                  on: {
                                    click: function($event) {
                                      return _vm.$emit("input", "center")
                                    }
                                  }
                                })
                              : _vm._e(),
                            _vm._v(" "),
                            _vm.value !== "right"
                              ? _c("editor-button", {
                                  attrs: {
                                    icon: "align_right",
                                    label: "Align right"
                                  },
                                  on: {
                                    click: function($event) {
                                      return _vm.$emit("input", "right")
                                    }
                                  }
                                })
                              : _vm._e()
                          ]
                        : _vm._e(),
                      _vm._v(" "),
                      _vm._t("options")
                    ],
                    2
                  )
                : _vm._e()
            ],
            2
          )
        ]
      )
    };
    var __vue_staticRenderFns__$b = [];
    __vue_render__$b._withStripped = true;

      /* style */
      const __vue_inject_styles__$b = function (inject) {
        if (!inject) return
        inject("data-v-2279e204_0", { source: ".node-has-options {\n  width: auto;\n  margin: 0 auto;\n}\n.node-has-options .options-inner {\n  position: relative;\n}\n.node-has-options .node-options {\n  background: #fff;\n  border: 1px solid #ccc;\n  padding: 5px;\n  position: absolute;\n  right: 0;\n  bottom: 100%;\n  display: flex;\n  align-items: center;\n}\n.node-has-options[lede-align=left] {\n  width: 100%;\n  height: 0;\n  z-index: 50;\n}\n.node-has-options[lede-align=left] .options-inner {\n  float: left;\n}\n.node-has-options[lede-align=left] .node-options {\n  left: 0;\n  right: auto;\n}\n.node-has-options[lede-align=right] {\n  width: 100%;\n  height: 0;\n  z-index: 50;\n}\n.node-has-options[lede-align=right] .options-inner {\n  float: right;\n}\n.node-has-options[lede-align=center] {\n  display: flex;\n  justify-content: center;\n}\n.node-has-options[lede-align=center] .options-inner {\n  display: inline-block;\n  margin: 0 auto;\n}\n\n/*# sourceMappingURL=NodeOptions.vue.map */", map: {"version":3,"sources":["Z:\\LedeCMF\\packages\\client\\Editor\\structured-editor\\packages\\structured-editor-ui\\src\\components\\NodeOptions.vue","NodeOptions.vue"],"names":[],"mappings":"AAoDA;EACA,WAAA;EACA,cAAA;ACnDA;ADqDA;EACA,kBAAA;ACnDA;ADsDA;EACA,gBAAA;EACA,sBAAA;EACA,YAAA;EACA,kBAAA;EACA,QAAA;EACA,YAAA;EACA,aAAA;EACA,mBAAA;ACpDA;ADuDA;EACA,WAAA;EACA,SAAA;EACA,WAAA;ACrDA;ADuDA;EACA,WAAA;ACrDA;ADwDA;EACA,OAAA;EACA,WAAA;ACtDA;AD0DA;EACA,WAAA;EACA,SAAA;EACA,WAAA;ACxDA;AD0DA;EACA,YAAA;ACxDA;AD4DA;EACA,aAAA;EACA,uBAAA;AC1DA;AD4DA;EACA,qBAAA;EACA,cAAA;AC1DA;;AAEA,0CAA0C","file":"NodeOptions.vue","sourcesContent":["<template>\r\n    <div class=\"node-has-options\" :class=\"{'is-selected' : selected}\" :lede-align=\"value\">\r\n        <div class=\"options-inner\">\r\n            <slot></slot>\r\n            <div class=\"node-options\" v-if=\"selected\">\r\n                <template v-if=\"options\">\r\n                    <editor-button icon=\"align_justify\" @click=\"$emit('input', '')\" v-if=\"!notAligned\"\r\n                                   label=\"Align none\"\r\n                    ></editor-button>\r\n                    <editor-button icon=\"align_left\" @click=\"$emit('input', 'left')\"\r\n                                   label=\"Align left\"\r\n                                   v-if=\"value !== 'left'\"></editor-button>\r\n                    <editor-button icon=\"align_center\" @click=\"$emit('input', 'center')\"\r\n                                   label=\"Align center\"\r\n                                   v-if=\"value !== 'center'\"></editor-button>\r\n                    <editor-button icon=\"align_right\" @click=\"$emit('input', 'right')\"\r\n                                   label=\"Align right\"\r\n                                   v-if=\"value !== 'right'\"></editor-button>\r\n                </template>\r\n                <slot name=\"options\"></slot>\r\n            </div>\r\n        </div>\r\n\r\n    </div>\r\n</template>\r\n\r\n<script>\r\n    import {EditorButton} from '@ledecmf/editor-core'\r\n    import NodeResizer from './NodeResizer.vue'\r\n\r\n    export default {\r\n        name: 'NodeOptions',\r\n        components: {NodeResizer, EditorButton},\r\n        props: {\r\n            selected: Boolean,\r\n            value: {\r\n                type: String,\r\n            },\r\n            options: {\r\n                type: Object,\r\n            },\r\n        },\r\n\r\n        computed: {\r\n            notAligned() {\r\n                return this.value !== 'left' && this.value !== 'right' && this.value !== 'center'\r\n            },\r\n        },\r\n    }\r\n</script>\r\n\r\n<style lang=\"scss\">\r\n    .node-has-options {\r\n        width: auto;\r\n        margin: 0 auto;\r\n\r\n        .options-inner {\r\n            position: relative;\r\n        }\r\n\r\n        .node-options {\r\n            background: #fff;\r\n            border: 1px solid #ccc;\r\n            padding: 5px;\r\n            position: absolute;\r\n            right: 0;\r\n            bottom: 100%;\r\n            display: flex;\r\n            align-items: center;\r\n        }\r\n\r\n        &[lede-align=\"left\"] {\r\n            width: 100%;\r\n            height: 0;\r\n            z-index: 50;\r\n\r\n            .options-inner {\r\n                float: left;\r\n            }\r\n\r\n            .node-options {\r\n                left: 0;\r\n                right: auto;\r\n            }\r\n        }\r\n\r\n        &[lede-align=\"right\"] {\r\n            width: 100%;\r\n            height: 0;\r\n            z-index: 50;\r\n\r\n            .options-inner {\r\n                float: right;\r\n            }\r\n        }\r\n\r\n        &[lede-align=\"center\"] {\r\n            display: flex;\r\n            justify-content: center;\r\n\r\n            .options-inner {\r\n                display: inline-block;\r\n                margin: 0 auto;\r\n            }\r\n        }\r\n    }\r\n</style>\r\n",".node-has-options {\n  width: auto;\n  margin: 0 auto;\n}\n.node-has-options .options-inner {\n  position: relative;\n}\n.node-has-options .node-options {\n  background: #fff;\n  border: 1px solid #ccc;\n  padding: 5px;\n  position: absolute;\n  right: 0;\n  bottom: 100%;\n  display: flex;\n  align-items: center;\n}\n.node-has-options[lede-align=left] {\n  width: 100%;\n  height: 0;\n  z-index: 50;\n}\n.node-has-options[lede-align=left] .options-inner {\n  float: left;\n}\n.node-has-options[lede-align=left] .node-options {\n  left: 0;\n  right: auto;\n}\n.node-has-options[lede-align=right] {\n  width: 100%;\n  height: 0;\n  z-index: 50;\n}\n.node-has-options[lede-align=right] .options-inner {\n  float: right;\n}\n.node-has-options[lede-align=center] {\n  display: flex;\n  justify-content: center;\n}\n.node-has-options[lede-align=center] .options-inner {\n  display: inline-block;\n  margin: 0 auto;\n}\n\n/*# sourceMappingURL=NodeOptions.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$b = undefined;
      /* module identifier */
      const __vue_module_identifier__$b = undefined;
      /* functional template */
      const __vue_is_functional_template__$b = false;
      /* style inject SSR */
      

      
      var NodeOptions = normalizeComponent_1(
        { render: __vue_render__$b, staticRenderFns: __vue_staticRenderFns__$b },
        __vue_inject_styles__$b,
        __vue_script__$b,
        __vue_scope_id__$b,
        __vue_is_functional_template__$b,
        __vue_module_identifier__$b,
        browser,
        undefined
      );

    //
    var script$c = {
      name: 'NodeAlign',
      components: {
        EditorButton: editorCore.EditorButton
      },
      props: {
        value: {
          type: String
        },
        options: {
          type: Object
        }
      }
    };

    /* script */
    const __vue_script__$c = script$c;

    /* template */
    var __vue_render__$c = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        { staticClass: "node-align" },
        [
          _c("editor-button", {
            attrs: { icon: "align_justify" },
            on: {
              click: function($event) {
                return _vm.$emit("update", "")
              }
            }
          }),
          _vm._v(" "),
          _c("editor-button", {
            attrs: { icon: "align_left" },
            on: {
              click: function($event) {
                return _vm.$emit("update", "left")
              }
            }
          }),
          _vm._v(" "),
          _c(
            "editor-button",
            {
              attrs: { icon: "align_center" },
              on: {
                click: function($event) {
                  return _vm.$emit("update", "center")
                }
              }
            },
            [_vm._v(">")]
          ),
          _vm._v(" "),
          _c(
            "editor-button",
            {
              attrs: { icon: "align_right" },
              on: {
                click: function($event) {
                  return _vm.$emit("update", "right")
                }
              }
            },
            [_vm._v(">")]
          )
        ],
        1
      )
    };
    var __vue_staticRenderFns__$c = [];
    __vue_render__$c._withStripped = true;

      /* style */
      const __vue_inject_styles__$c = function (inject) {
        if (!inject) return
        inject("data-v-497eefc8_0", { source: "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n", map: {"version":3,"sources":[],"names":[],"mappings":"","file":"NodeAlign.vue"}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$c = "data-v-497eefc8";
      /* module identifier */
      const __vue_module_identifier__$c = undefined;
      /* functional template */
      const __vue_is_functional_template__$c = false;
      /* style inject SSR */
      

      
      var NodeAlign = normalizeComponent_1(
        { render: __vue_render__$c, staticRenderFns: __vue_staticRenderFns__$c },
        __vue_inject_styles__$c,
        __vue_script__$c,
        __vue_scope_id__$c,
        __vue_is_functional_template__$c,
        __vue_module_identifier__$c,
        browser,
        undefined
      );

    function _typeof(obj) {
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function (obj) {
          return typeof obj;
        };
      } else {
        _typeof = function (obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);
      if (staticProps) _defineProperties(Constructor, staticProps);
      return Constructor;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }

      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      });
      if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return self;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (typeof call === "object" || typeof call === "function")) {
        return call;
      }

      return _assertThisInitialized(self);
    }

    var MenuItem$1 =
    /*#__PURE__*/
    function () {
      function MenuItem(label, command, icon) {
        _classCallCheck(this, MenuItem);

        this.label = label;
        this._command = command;
        this.icon = icon;
      }

      _createClass(MenuItem, [{
        key: "isActive",
        value: function isActive(editor) {
          return editor.commands[this.command.name] ? editor.commands[this.command.name](this.command.attrs) : false;
        }
      }, {
        key: "isAvailable",
        value: function isAvailable(editor) {
          return true;
        }
      }, {
        key: "enabled",
        value: function enabled() {}
      }, {
        key: "command",
        value: function command(state) {}
      }, {
        key: "component",
        get: function get() {
          return false;
        }
      }]);

      return MenuItem;
    }();

    var BlockTypeMenu =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(BlockTypeMenu, _MenuItem);

      function BlockTypeMenu() {
        var _this;

        _classCallCheck(this, BlockTypeMenu);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(BlockTypeMenu).call(this));
        _this._items = [];

        _this._items.push({
          label: 'paragraph',
          command: 'paragraph',
          attrs: {}
        });

        return _this;
      }

      _createClass(BlockTypeMenu, [{
        key: "add",
        value: function add(label, command, attrs) {
          if (label instanceof structuredEditorExtensions.Node) {
            label.blockTypes(this);
          } else {
            this._items.push({
              label: label,
              command: command,
              attrs: attrs
            });
          }

          return this;
        }
      }, {
        key: "all",
        value: function all() {
          return this._items;
        }
      }, {
        key: "component",
        get: function get() {
          return BlockTypeSelector;
        }
      }]);

      return BlockTypeMenu;
    }(MenuItem$1);

    var ExtensionMenuItem =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(ExtensionMenuItem, _MenuItem);

      function ExtensionMenuItem(item) {
        _classCallCheck(this, ExtensionMenuItem);

        return _possibleConstructorReturn(this, _getPrototypeOf(ExtensionMenuItem).call(this, item.label, item, item.icon));
      }

      _createClass(ExtensionMenuItem, [{
        key: "command",
        value: function command(editor, attrs) {
          if (!attrs) {
            attrs = {};
          }

          editor.commands[this._command.name](attrs);
        }
      }, {
        key: "isActive",
        value: function isActive(editor) {
          if (structuredEditorUtils.isFunction(this._command.isActive)) {
            return this._command.isActive(editor);
          }

          return editor.isActive[this._command.name]();
        }
      }, {
        key: "isAvailable",
        value: function isAvailable(editor) {
          if (structuredEditorUtils.isFunction(this._command.isAvailable)) {
            return this._command.isAvailable(editor);
          }

          return true;
        }
      }, {
        key: "component",
        get: function get() {
          return this._command.menu;
        }
      }]);

      return ExtensionMenuItem;
    }(MenuItem$1);

    var EditorMenu =
    /*#__PURE__*/
    function () {
      function EditorMenu() {
        _classCallCheck(this, EditorMenu);

        this._items = [];
      }

      _createClass(EditorMenu, [{
        key: "add",
        value: function add(label, command, icon) {
          this._items.push(this.transformItem(label, command, icon));

          return this;
        }
      }, {
        key: "transformItem",
        value: function transformItem(label, command, icon) {
          if (command) {
            command = _typeof(command) === 'object' ? command : {
              command: command
            };
            return new MenuItem$1(label, command, icon);
          } else if (this.isExtension(label)) {
            return new ExtensionMenuItem(label);
          } else if (structuredEditorUtils.isFunction(label)) {
            return label();
          } else {
            return label;
          }
        }
      }, {
        key: "isExtension",
        value: function isExtension(item) {
          return item && (item instanceof structuredEditorExtensions.Node || item instanceof structuredEditorExtensions.Mark || item instanceof structuredEditorExtensions.Extension);
        }
      }, {
        key: "all",
        value: function all() {
          return this._items;
        }
      }]);

      return EditorMenu;
    }();

    var MenuDivider =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(MenuDivider, _MenuItem);

      function MenuDivider() {
        _classCallCheck(this, MenuDivider);

        return _possibleConstructorReturn(this, _getPrototypeOf(MenuDivider).call(this, null, null, null));
      }

      _createClass(MenuDivider, [{
        key: "command",
        value: function command(state) {
          return true;
        }
      }, {
        key: "component",
        value: function component() {
          return MenuSeparator;
        }
      }]);

      return MenuDivider;
    }(MenuItem$1);

    var InsertMenuCollection =
    /*#__PURE__*/
    function (_EditorMenu) {
      _inherits(InsertMenuCollection, _EditorMenu);

      function InsertMenuCollection() {
        var _this;

        _classCallCheck(this, InsertMenuCollection);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(InsertMenuCollection).call(this));
        _this._quick = [];
        _this.settings = {
          collapse: 200
        };
        return _this;
      }

      _createClass(InsertMenuCollection, [{
        key: "set",
        value: function set(setting, value) {
          this.settings[setting] = value;
          return this;
        }
      }, {
        key: "quick",
        value: function quick(label, icon, command) {
          var item = this.transformItem(label, icon, command);

          this._quick.push(item);

          this._items.push(item);

          return this;
        }
      }, {
        key: "quickItems",
        value: function quickItems() {
          return this._quick;
        }
      }]);

      return InsertMenuCollection;
    }(EditorMenu);

    exports.BlockMenu = BlockMenu;
    exports.BlockTypeMenu = BlockTypeMenu;
    exports.BlockTypeSelector = BlockTypeSelector;
    exports.EditorMenu = EditorMenu;
    exports.ExtensionMenuItem = ExtensionMenuItem;
    exports.InsertMenu = InsertMenu;
    exports.InsertMenuCollection = InsertMenuCollection;
    exports.MenuBar = MenuBar;
    exports.MenuDivider = MenuDivider;
    exports.MenuDropButton = MenuDropButton;
    exports.MenuItem = MenuItem;
    exports.MenuItemCollection = MenuItem$1;
    exports.MenuSeparator = MenuSeparator;
    exports.NodeAlign = NodeAlign;
    exports.NodeOptions = NodeOptions;
    exports.NodeResizer = NodeResizer;
    exports.SelectionMenu = SelectionMenu;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
